#include "precomp.h" // include this first in every .cpp file
#include "game.h"

namespace Tmpl8
{



	static Sprite asteroid1(new Surface("assets/asteroid1.png"), 180);
	static Sprite asteroid2(new Surface("assets/asteroid2.png"), 180);
	static Sprite asteroid3(new Surface("assets/asteroid3.png"), 180);
	static Sprite player(new Surface("assets/player.png"), 90);
	static Sprite enemy(new Surface("assets/enemyship2.png"), 1);
	static Sprite gameover(new Surface("assets/gameover.png"), 1);
	static Sprite score(new Surface("assets/score.png"), 1);
	static Sprite number(new Surface("assets/numbers.png"), 10);

	bool DebugHitbox = false;

	int ShootWait = 1;
	bool Alive = 1;
	int Lives = 3;
	int DeadTimer = 0;
	bool GameOver = 0;
	int Score = 0;

	int asteroidRotation = 0;
	bool Thrust = 0;
	bool RotateCW = 0;
	bool RotateCCW = 0;
	bool Shoot = 0;
	int Wave = 0;
	int AsteroidsOnScreen = 0;
	Asteroids Asteroid[100];
	Asteroids AsteroidStartup;
	Bullets Bullet[100];
	Bullets BulletStartup;
	Player ShipStartup;
	Enemy EnemyStartup;

	void Game::KeyDown(int key)
	{
		switch (key) {
		case 4:			//a
			RotateCCW = 1;
			break;
		case 7:			//d
			RotateCW = 1;
			break;
		case 26:		//w
			Thrust = 1;
			break;
		case 44:		//space
			Shoot = 1;
			break;
		}
	}

	void Game::KeyUp(int key)
	{
		switch (key) {
		case 4:			//a
			RotateCCW = 0;
			break;
		case 7:			//d
			RotateCW = 0;
			break;
		case 26:		//w
			Thrust = 0;
			break;
		case 44:		//space
			Shoot = 0;
			break;
		}
	}

	void Game::Init()
	{
		AsteroidStartup.StartAsteroids();
		BulletStartup.StartBullets();
	}

	void Game::Tick(float deltaTime)
	{
		if (GameOver) {
			gameover.Draw(screen, 960 - 68, 540 - 9);
		}
		else {
			screen->Clear(0);

			if (--DeadTimer == 0) {
				ShipStartup.PlayerAlive();
			}

			if (Shoot) {
				if (ShipStartup.GetPlayerAlive()) {
					if (--ShootWait == 0) {
						BulletStartup.NewBullet(true);
						ShootWait = 20;
					}
				}
			}

			if (AsteroidsOnScreen <= 0) {
				++Wave;
				ShipStartup.PlayerNewWave();
				for (int i = 0; i < 100; i++)
				{
					Bullet[i].SetBulletInUse(false);
				}
				SpawnAsteroids(Wave * 2 + 2);
				AsteroidsOnScreen = Wave * 2 + 2;
			}

			if (RotateCCW) ShipStartup.PlayerRotateCCW();
			if (RotateCW) ShipStartup.PlayerRotateCW();

			DrawBullets();
			DrawAsteroids();
			DrawEnemy();
			DrawShip();
			DrawScore();
			CheckCollision();
		}
	}

	void Game::SpawnAsteroids(int amount)
	{
		int spawned = 0;

		for (int i = 0; i < 100; i++) {
			if (spawned < amount) {
				if (!Asteroid[i].GetAsteroidInUse()) {
					Asteroid[i].StartupAsteroid();
					Asteroid[i].SetAsteroidInUse(true);
					spawned++;
				}
			}
		}
	}

	void Game::DrawBullets()
	{
		int x;
		int y;
		int x2;
		int y2;
		bool color;
		for (int i = 0; i < 100; i++) {
			if (Bullet[i].GetBulletInUse()) {

				x = Bullet[i].GetBulletX();
				y = Bullet[i].GetBulletY();
				x2 = x - Bullet[i].GetBulletVelX() * 10;
				y2 = y - Bullet[i].GetBulletVelY() * 10;
				color = Bullet[i].GetBulletWhite();

				if (color) {
					screen->Line(x, y, x2, y2, 0xffffff);
				}
				else {
					screen->Line(x, y, x2, y2, 0xff6464);
				}

				Bullet[i].BulletMove();
			}
		}
	}

	void Game::DrawAsteroids()
	{
		int x;
		int y;
		int size;

		for (int i = 0; i < 100; i++) {
			if (Asteroid[i].GetAsteroidInUse()) {

				x = Asteroid[i].GetAsteroidX();
				y = Asteroid[i].GetAsteroidY();
				size = Asteroid[i].GetAsteroidSize();

				switch (size) {
				case 1:
					size = 64;
					asteroid1.Draw(screen, x, y);
					break;
				case 2:
					size = 32;
					asteroid2.Draw(screen, x, y);
					break;
				case 3:
					size = 16;
					asteroid3.Draw(screen, x, y);
					break;
				}

				if (DebugHitbox) {
					screen->Line(x, y, x + size, y, 0xffffff);
					screen->Line(x + size, y, x + size, y + size, 0xffffff);
					screen->Line(x + size, y + size, x, y + size, 0xffffff);
					screen->Line(x, y + size, x, y, 0xffffff);
				}

				Asteroid[i].AsteroidMove();
			}
		}

		asteroid1.SetFrame(asteroidRotation);
		asteroid2.SetFrame(asteroidRotation);
		asteroid3.SetFrame(asteroidRotation);
		if (++asteroidRotation == 180) asteroidRotation = 0;
	}

	void Game::DrawShip()
	{
		player.SetFrame(23);
		switch (Lives) {
		case 3:
			player.Draw(screen, 64 * 2, 10 + 30);
		case 2:
			player.Draw(screen, 64, 10 + 30);
		case 1:
			player.Draw(screen, 0, 10 + 30);
		}

		int x = ShipStartup.GetPlayerX();
		int y = ShipStartup.GetPlayerY();

		player.SetFrame(ShipStartup.GetPlayerRotation());
		player.Draw(screen, x, y);
		
		if (DebugHitbox) {
			screen->Line(x, y, x + 64, y, 0xffffff);
			screen->Line(x + 64, y, x + 64, y + 64, 0xffffff);
			screen->Line(x + 64, y + 64, x, y + 64, 0xffffff);
			screen->Line(x, y + 64, x, y, 0xffffff);
		}

		ShipStartup.PlayerMove(Thrust);
	}

	void Game::DrawEnemy()
	{
		if (EnemyStartup.GetEnemyInUse()) {
			int x = EnemyStartup.GetEnemyX();
			int y = EnemyStartup.GetEnemyY();;

			enemy.Draw(screen, x, y);

			if (DebugHitbox) {
				screen->Line(x, y, x + 55, y, 0xffffff);
				screen->Line(x + 55, y, x + 55, y + 28, 0xffffff);
				screen->Line(x + 55, y + 28, x, y + 28, 0xffffff);
				screen->Line(x, y + 28, x, y, 0xffffff);
			}
		}

		EnemyStartup.EnemyMove();
	}

	void Game::CheckCollision()
	{
		int x;
		int y;
		int size;
		int playerX;
		int playerY;
		int enemyX;
		int enemyY;
		int bulletX;
		int bulletY;
		bool bulletWhite;

		for (int i = 0; i < 100; ++i) {
			if (Asteroid[i].GetAsteroidInUse()) {
				playerX = ShipStartup.GetPlayerX();
				playerY = ShipStartup.GetPlayerY();
				enemyX = EnemyStartup.GetEnemyX();
				enemyY = EnemyStartup.GetEnemyY();
				x = Asteroid[i].GetAsteroidX();
				y = Asteroid[i].GetAsteroidY();
				size = 64 / Asteroid[i].GetAsteroidSize();

				//check for collision between the asteroid and the player
				if (x < playerX + 64 && x + size > playerX && y < playerY + 64 && y + size > playerY) {
					ShipStartup.PlayerDead();
					DeadTimer = 500;
					Asteroid[i].AsteroidSplit();
					if (--Lives == 0) {
						GameOver = 1;
					}
				}

				//check for collision between the asteroid and the enemy
				if (x < enemyX + 55 && x + size > enemyX && y < enemyY + 28 && y + size > enemyY) {
					EnemyStartup.EnemyDead();
					Asteroid[i].AsteroidSplit();
				}

				for (int j = 0; j < 100; j++) {
					if (Bullet[j].GetBulletInUse()) {
						bulletX = Bullet[j].GetBulletX();
						bulletY = Bullet[j].GetBulletY();
						bulletWhite = Bullet[j].GetBulletWhite();

						//check for collision between the asteroid and the bullets
						if (x < bulletX && x + size > bulletX && y < bulletY && y + size > bulletY) {
							if (bulletWhite) {
								switch (Asteroid[i].GetAsteroidSize()) {
								case 1:
									Score += 20;
									break;
								case 2:
									Score += 50;
									break;
								case 3:
									Score += 100;
									break;
								}
							}

							Bullet[j].SetBulletInUse(false);
							Asteroid[i].AsteroidSplit();
						}
					}
				}
			}
		}

		playerX = ShipStartup.GetPlayerX();
		playerY = ShipStartup.GetPlayerY();
		enemyX = EnemyStartup.GetEnemyX();
		enemyY = EnemyStartup.GetEnemyY();

		//check for collision between the enemy and the player
		if (enemyX < playerX + 64 && enemyX + 55 > playerX && enemyY < playerY + 64 && enemyY + 28 > playerY) {
			ShipStartup.PlayerDead();
			DeadTimer = 500;
			EnemyStartup.EnemyDead();
			if (--Lives == 0) {
				GameOver = 1;
			}
		}

		for (int j = 0; j < 100; j++) {
			if (Bullet[j].GetBulletInUse()) {
				bulletX = Bullet[j].GetBulletX();
				bulletY = Bullet[j].GetBulletY();
				bulletWhite = Bullet[j].GetBulletWhite();
				playerX = ShipStartup.GetPlayerX();
				playerY = ShipStartup.GetPlayerY();
				enemyX = EnemyStartup.GetEnemyX();
				enemyY = EnemyStartup.GetEnemyY();

				if (bulletWhite) {

					//check for collision between the enemy and the bullets
					if (enemyX < bulletX && enemyX + 55 > bulletX && enemyY < bulletY && enemyY + 28 > bulletY) {
						Bullet[j].SetBulletInUse(false);
						EnemyStartup.EnemyDead();
						Score += 200;
					}
				}
				else {

					//check for collision between the player and the bullets
					if (playerX < bulletX && playerX + 64 > bulletX && playerY < bulletY && playerY + 64 > bulletY) {
						ShipStartup.PlayerDead();
						DeadTimer = 500;
						Bullet[j].SetBulletInUse(false);
						if (--Lives == 0) {
							GameOver = 1;
						}
					}
				}
			}
		}


	}

	void Game::DrawScore()
	{
		score.Draw(screen, 10, 10);
		int x = 89;

		char ScoreLength[33];
		itoa(Score, ScoreLength, 10);

		for (int i = 0; i < strlen(ScoreLength); i++) {
			number.SetFrame(ScoreLength[i] - '0');
			number.Draw(screen, x, 10);

			x += 15;
		}
	}





	void Player::PlayerMove(bool ThrustOn)
	{
		if (Alive) {
			if (ThrustOn) {
				PlayerDirection = PlayerRotation * 3.95;
				PlayerVelX = cos(PlayerDirection * PI / 180);
				PlayerVelY = -sin(PlayerDirection * PI / 180);

				if ((PlayerSpeedX < 5 && PlayerVelX > 0) || (PlayerSpeedX > -5 && PlayerVelX < 0)) {
					PlayerSpeedX += PlayerVelX / 100;
				}
				if ((PlayerSpeedY < 5 && PlayerVelY > 0) || (PlayerSpeedY > -5 && PlayerVelY < 0)) {
					PlayerSpeedY += PlayerVelY / 100;
				}
			}
			PlayerX += PlayerSpeedX;
			PlayerY += PlayerSpeedY;

			if (PlayerX > SCRWIDTH) {
				PlayerX = -64;
			}
			if (PlayerY > SCRHEIGHT) {
				PlayerY = -64;
			}
			if (PlayerX < -64) {
				PlayerX = SCRWIDTH;
			}
			if (PlayerY < -64) {
				PlayerY = SCRHEIGHT;
			}
		}
	}

	void Player::PlayerDead()
	{
		Alive = false;
		PlayerVelX = 0;
		PlayerVelY = 0;
		PlayerSpeedX = 0;
		PlayerSpeedY = 0;
		PlayerX = 2000;
		PlayerY = 2000;
	}

	void Player::PlayerAlive()
	{
		Alive = 1;
		PlayerX = 960 - 32;
		PlayerY = 540 - 32;
		PlayerRotation = 23;
	}

	void Player::PlayerNewWave()
	{
		PlayerVelX = 0;
		PlayerVelY = 0;
		PlayerSpeedX = 0;
		PlayerSpeedY = 0;
		PlayerX = 960 - 32;
		PlayerY = 540 - 32;
		PlayerRotation = 23;
	}

	void Player::PlayerRotateCW() { if (--PlayerRotation == -1) PlayerRotation = 89; }
	void Player::PlayerRotateCCW() { if (++PlayerRotation == 90) PlayerRotation = 0; }

	float Player::GetPlayerX() { return PlayerX; }
	float Player::GetPlayerY() { return PlayerY; }
	int Player::GetPlayerRotation() { return PlayerRotation; }
	bool Player::GetPlayerAlive() { return Alive; }





	void Asteroids::StartAsteroids()
	{
		for (int i = 0; i < 100; i++) {
			AsteroidStartup.StartupAsteroid();
			Asteroid[i] = AsteroidStartup;
		}
	}

	void Asteroids::StartupAsteroid()
	{
		AsteroidX = rand() % SCRWIDTH;
		AsteroidY = rand() % SCRHEIGHT;
		AsteroidSize = 1;
		AsteroidInUse = 0;

		AsteroidVelX = (rand() % 201) / 100.0 - 1.0;
		AsteroidVelY = (rand() % 201) / 100.0 - 1.0;
	}

	void Asteroids::AsteroidMove()
	{
		AsteroidX += AsteroidVelX * (float)AsteroidSize * 0.5;
		AsteroidY += AsteroidVelY * (float)AsteroidSize * 0.5;
		

		switch (AsteroidSize) {
		case 1:
			size = 64;
			break;
		case 2:
			size = 32;
			break;
		case 3:
			size = 16;
			break;
		}

		if (AsteroidX > SCRWIDTH) {
			AsteroidX = -size;
		}
		if (AsteroidY > SCRHEIGHT) {
			AsteroidY = -size;
		}
		if (AsteroidX < -size) {
			AsteroidX = SCRWIDTH;
		}
		if (AsteroidY < -size) {
			AsteroidY = SCRHEIGHT;
		}
	}

	void Asteroids::AsteroidSplit()
	{
		if (AsteroidInUse) {
			AsteroidSize++;
			if (AsteroidSize >= 4) {
				AsteroidsOnScreen--;
				AsteroidInUse = false;
				AsteroidX = -2000;
				AsteroidY = -2000;
				AsteroidVelX = 0;
				AsteroidVelY = 0;
				AsteroidSize = 1;
			}
			else {
				AsteroidsOnScreen++;
				AsteroidX += size / 4;
				AsteroidY += size / 4;
				AsteroidVelX = (rand() % 201) / 100.0 - 1.0;
				AsteroidVelY = (rand() % 201) / 100.0 - 1.0;
				for (int i = 0; i < 100; i++) {
					if (!Asteroid[i].GetAsteroidInUse()) {
						Asteroid[i].SetAsteroidInUse(true);
						Asteroid[i].SetAsteroidPos(AsteroidX, AsteroidY);
						Asteroid[i].SetAsteroidSize(AsteroidSize);
						break;
					}
				}
			}
		}
	}	

	float Asteroids::GetAsteroidX() { return AsteroidX; }
	float Asteroids::GetAsteroidY() { return AsteroidY; }
	float Asteroids::GetAsteroidVelX() { return AsteroidVelX; }
	float Asteroids::GetAsteroidVelY() { return AsteroidVelY; }
	int Asteroids::GetAsteroidSize() { return AsteroidSize; }
	bool Asteroids::GetAsteroidInUse() { return AsteroidInUse; }

	void Asteroids::SetAsteroidInUse(bool InUse) { AsteroidInUse = InUse; }
	void Asteroids::SetAsteroidPos(float x, float y) { AsteroidX = x; AsteroidY = y; }
	void Asteroids::SetAsteroidSize(int size) { AsteroidSize = size; }





	void Bullets::StartBullets()
	{
		for (int i = 0; i < 100; i++) {
			BulletStartup.StartupBullet();
			Bullet[i] = BulletStartup;
		}
	}

	void Bullets::StartupBullet() { BulletInUse = false; }

	void Bullets::SpawnBullet(bool White)
	{
		BulletWhite = White;
		BulletDespawnTimer = 0;
		BulletInUse = true;
		if (BulletWhite) {
			BulletX = ShipStartup.GetPlayerX() + 32;
			BulletY = ShipStartup.GetPlayerY() + 32;
			BulletFrame = (ShipStartup.GetPlayerRotation() * 3.95);		//in degree
			BulletVelX = cos(BulletFrame * PI / 180);
			BulletVelY = -sin(BulletFrame * PI / 180);
		}
		else {
			BulletX = EnemyStartup.GetEnemyX() + 27.5;
			BulletY = EnemyStartup.GetEnemyY() + 14;

			float DeltaX = (EnemyStartup.GetEnemyX() + 27.5) - (ShipStartup.GetPlayerX() + 32.0);
			float DeltaY = (EnemyStartup.GetEnemyY() + 14.0) - (ShipStartup.GetPlayerY() + 32.0);

			if (DeltaX > 0) {
				BulletVelX = -cos(atan(DeltaY / DeltaX));
				BulletVelY = -sin(atan(DeltaY / DeltaX));
			}
			else {
				BulletVelX = cos(atan(DeltaY / DeltaX));
				BulletVelY = sin(atan(DeltaY / DeltaX));
			}
		}
	}

	void Bullets::BulletMove()
	{
		if (++BulletDespawnTimer == 300) {
			BulletInUse = false;
		}
		else {
			BulletX += BulletVelX * 2;
			BulletY += BulletVelY * 2;

			if (BulletX > SCRWIDTH) {
				BulletX = -16;
			}
			if (BulletY > SCRHEIGHT) {
				BulletY = -16;
			}
			if (BulletX < -16) {
				BulletX = SCRWIDTH;
			}
			if (BulletY < -16) {
				BulletY = SCRHEIGHT;
			}
		}
	}

	void Bullets::NewBullet(bool White)
	{
		for (int i = 0; i < 100; i++) {
			if (!Bullet[i].GetBulletInUse()) {
				Bullet[i].SpawnBullet(White);
				break;
			}
		}
	}

	bool Bullets::GetBulletInUse() { return BulletInUse; }
	float Bullets::GetBulletX() { return BulletX; }
	float Bullets::GetBulletY() { return BulletY; }
	int Bullets::GetBulletFrame() { return BulletFrame; }
	float Bullets::GetBulletVelX() { return BulletVelX; }
	float Bullets::GetBulletVelY() { return BulletVelY; }
	bool Bullets::GetBulletWhite() { return BulletWhite; }

	void Bullets::SetBulletInUse(bool InUse) { BulletInUse = InUse; }





	void Enemy::EnemyMove()
	{
		if (!EnemyInUse) {
			if (--EnemySpawnTimer == 0) {
				EnemyStartup.EnemyStart();
			}
		}
		else {
			if (--EnemyMoveTimer == 0) {
				EnemyMoveTimer = rand() % 300 + 150;
				EnemyVelX = (rand() % 201) / 100.0 - 1.0;
				EnemyVelY = (rand() % 201) / 100.0 - 1.0;
			}

			if (--EnemyShootTimer <= 0) {
				if (ShipStartup.GetPlayerAlive()) {
					EnemyShootTimer = 300;
					BulletStartup.NewBullet(false);
				}
			}

			EnemyX += EnemyVelX * 2;
			EnemyY += EnemyVelY * 2;

			if (EnemyX > SCRWIDTH) {
				EnemyX = -55;
			}
			if (EnemyY > SCRHEIGHT) {
				EnemyY = -28;
			}
			if (EnemyX < -55) {
				EnemyX = SCRWIDTH;
			}
			if (EnemyY < -28) {
				EnemyY = SCRHEIGHT;
			}
		}
	}

	void Enemy::EnemyStart()
	{
		EnemyInUse = true;
		EnemyX = -55;
		EnemyY = 100;
		EnemyVelX = (rand() % 201) / 100.0 - 1.0;
		EnemyVelY = (rand() % 201) / 100.0 - 1.0;
		EnemyMoveTimer = 300;
		EnemyShootTimer = 300;
	}

	void Enemy::EnemyDead()
	{
		EnemyX = 2000;
		EnemyY = -2000;
		EnemyInUse = false;
		EnemyVelX = 0;
		EnemyVelY = 0;
		EnemySpawnTimer = 1500;
	}

	float Enemy::GetEnemyX() { return EnemyX; }
	float Enemy::GetEnemyY() { return EnemyY; }
	bool Enemy::GetEnemyInUse() { return EnemyInUse; }
};