#pragma once

namespace Tmpl8 {

	class Game
	{
	public:
		void SetTarget( Surface* surface ) { screen = surface; }
		void Init();
		void Shutdown() {}
		void Tick( float deltaTime );
		void MouseUp( int button ) { /* implement if you want to detect mouse button presses */ }
		void MouseDown( int button ) { /* implement if you want to detect mouse button presses */ }
		void MouseMove( int x, int y ) { /* implement if you want to detect mouse movement */ }
		void KeyUp(int key);
		void KeyDown(int key);

		void DrawAsteroids();
		void DrawShip();
		void DrawBullets();
		void DrawEnemy();
		void DrawGameOver();
		void DrawScore();

		void SpawnAsteroids(int Amount);
		void CheckCollision();
	private:
		Surface* screen;
	};

	class Asteroids
	{
	private:
		float AsteroidX;
		float AsteroidY;
		int AsteroidSize;
		float AsteroidVelX;
		float AsteroidVelY;
		bool AsteroidInUse;
		int size;

	public:
		void StartAsteroids();
		void StartupAsteroid();
		void AsteroidMove();
		void AsteroidSplit();

		float GetAsteroidX();
		float GetAsteroidY();
		float GetAsteroidVelX();
		float GetAsteroidVelY();
		int GetAsteroidSize();
		bool GetAsteroidInUse();

		void SetAsteroidInUse(bool InUse);
		void SetAsteroidPos(float x, float y);
		void SetAsteroidSize(int size);
	};

	class Player
	{
	private:
		float PlayerX = 960 - 32;
		float PlayerY = 540 - 32;
		float PlayerVelX;
		float PlayerVelY;
		int PlayerDirection;			//Direction of the player in degree
		int PlayerRotation = 23;		//Amount of frames needed for the correct rotation
		float PlayerSpeedX;
		float PlayerSpeedY;
		bool Alive = 1;

	public:
		void PlayerMove(bool ThrustOn);
		void PlayerRotateCW();
		void PlayerRotateCCW();
		void PlayerDead();
		void PlayerAlive();
		void PlayerNewWave();

		float GetPlayerX();
		float GetPlayerY();
		int GetPlayerRotation();
		bool GetPlayerAlive();
	};

	class Bullets
	{
	private:
		float BulletX;
		float BulletY;
		float BulletVelX;
		float BulletVelY;
		bool BulletInUse;
		int BulletFrame;
		int BulletDespawnTimer;
		bool BulletWhite;

	public:
		void StartBullets();
		void StartupBullet();
		void SpawnBullet(bool White);
		void BulletMove();
		void NewBullet(bool White);

		bool GetBulletInUse();
		float GetBulletX();
		float GetBulletY();
		int GetBulletFrame();
		float GetBulletVelX();
		float GetBulletVelY();
		bool GetBulletWhite();

		void SetBulletInUse(bool InUse);
	};

	class Enemy
	{
	private:
		float EnemyX = 2000;
		float EnemyY = -2000;
		float EnemyVelX;
		float EnemyVelY;
		bool EnemyInUse = false;
		int EnemySpawnTimer = 1500;
		int EnemyMoveTimer;
		int EnemyShootTimer;

	public:
		void EnemyMove();
		void EnemyStart();
		void EnemyDead();

		float GetEnemyX();
		float GetEnemyY();
		bool GetEnemyInUse();
	};
}; // namespace Tmpl8